import type { DryRunTransactionBlockResponse } from "@mysten/sui.js/client";
export interface BalanceChange {
    /**
     * The amount indicate the balance value changes, negative amount means spending coin value and
     * positive means receiving coin value.
     */
    amount: string;
    coinType: string;
}
export type SuiObjectChange = {
    objectId: string;
    objectType: string;
    type: string;
    version: string;
} | {
    objectId: string;
    objectType: string;
    previousVersion: string;
    type: "mutated";
    version: string;
};
export interface SenderChange {
    balanceChanges: BalanceChange[];
    objectChanges: SuiObjectChange[];
}
export interface DryRunTransactionBlockResponsePlus {
    senderChange: SenderChange;
    dryRunTransactionBlockResponse: DryRunTransactionBlockResponse;
}
export declare const parseDryRunResult: (res: DryRunTransactionBlockResponse) => DryRunTransactionBlockResponsePlus;
//# sourceMappingURL=index.d.ts.map