export const parseDryRunResult = (res) => {
    const balanceChanges = res.balanceChanges;
    const objectChanges = res.objectChanges;
    console.log(balanceChanges);
    const sender = res.input.sender;
    const balanceIncrease = [];
    const balanceDecrease = [];
    const moreObjects = [];
    const lessObjects = [];
    const mutatedObjects = [];
    for (const balanceChange of balanceChanges) {
        if (balanceChange.owner.AddressOwner !== sender) {
            continue;
        }
        const newBalanceChange = {
            amount: balanceChange.amount,
            coinType: balanceChange.coinType,
        };
        if (balanceChange.amount.startsWith("-")) {
            balanceDecrease.push(newBalanceChange);
        }
        else {
            balanceIncrease.push(newBalanceChange);
        }
    }
    for (const objectChange of objectChanges) {
        if (objectChange.type === "transferred") {
            if (objectChange.sender === objectChange.recipient.AddressOwner) {
                continue;
            }
            if (objectChange.sender === sender) {
                const newObjectChange = {
                    objectId: objectChange.objectId,
                    objectType: objectChange.objectType,
                    type: "Remove",
                    version: objectChange.version,
                };
                lessObjects.push(newObjectChange);
            }
            if (objectChange.recipient.AddressOwner ===
                sender) {
                const newObjectChange = {
                    objectId: objectChange.objectId,
                    objectType: objectChange.objectType,
                    type: "Add",
                    version: objectChange.version,
                };
                moreObjects.push(newObjectChange);
            }
        }
        if (objectChange.type === "deleted" && objectChange.sender === sender) {
            const newObjectChange = {
                objectId: objectChange.objectId,
                objectType: objectChange.objectType,
                type: "Remove",
                version: objectChange.version,
            };
            lessObjects.push(newObjectChange);
        }
        if (objectChange.type === "created" && objectChange.owner === sender) {
            const newObjectChange = {
                objectId: objectChange.objectId,
                objectType: objectChange.objectType,
                type: "Add",
                version: objectChange.version,
            };
            moreObjects.push(newObjectChange);
        }
        if (objectChange.type === "mutated" && objectChange.owner === sender) {
            const newObjectChange = {
                objectId: objectChange.objectId,
                objectType: objectChange.objectType,
                previousVersion: objectChange.previousVersion,
                type: "mutated",
                version: objectChange.version,
            };
            mutatedObjects.push(newObjectChange);
        }
    }
    const newSenderChange = {
        balanceChanges: balanceDecrease.concat(balanceIncrease),
        objectChanges: lessObjects.concat(moreObjects).concat(mutatedObjects),
    };
    const dryRunTransactionBlockResponsePlus = {
        senderChange: newSenderChange,
        dryRunTransactionBlockResponse: res,
    };
    return dryRunTransactionBlockResponsePlus;
};
//# sourceMappingURL=index.js.map